; =======================================================================================================
; FLO2V / COPY DISK to VDK
; This dweeb will be loaded by DLOAD this way:
; DLOAD"FLO2V""DiskName.VDK"
; It will send the disk inserted into the default drive to DW4
; It creates a VDK header according to the geometry of the disk to be copied
; It will read packs of 90 sectors from disk (5 tracks x 18 sectors each), and send them to DW4
; By now cannot create a named oject in DW4 because it returns uknown opcode.
; Accepts this syntax too: DLOAD"FLO2V""DiskName"
; and it will add the .VDK extension if none present in command line
; Copies DOS and OS-9 / NitrOS-9 disks as well
; In this case the geometry resides in sector 1 (just after the header)
; Fist byte is offset 0, then data is at offset 01-02. This is the total number of sectors to be copied
; Offset 1-2 (16 bits) contains 720-1440-2880 upon the disk type
; =======================================================================================================
; Trying to substitute the call to $C104 by a call to ($C028) requires more code to get the right LSN!
; If code block to "Update working DOS variables" is omitted, then it does not read from floppy!
; =======================================================================================================
       ORG   $1800
       PUT   $1800
;
DNUM   EQU   $12							; assigned drive number by DW4 server
CHKSUM EQU   $F7							; checksum of the sector to be send to DW4 (2 bytes)
numsec equ	 $F9							; number of sectors per track
SEC1ST EQU   $76							; 1ST sector number to read-send in a pack (2 Bytes) - (0-2879) 
CURPOS EQU   $88							; actual cursor position
totsec EQU   $E6							; total number of tracks to be copied - 1 (2 bytes) - (719-2879) 
WRKDRV EQU   $EB							; drive for the command to be executed
WRKTRK EQU   $EC							; track - sector to access (2 bytes)
WRKBUF EQU   $EE							; buffer where data is to be written to-sent from (2 bytes)
MOTTIM EQU   $0605                  ; motor timer
DEFDRV EQU   $060A                  ; default floppy drive number
DRVINF EQU   $0616                  ; base to Drive info    (D1: $61C - D2: $622 - D3: $628 - D4: $62E  step = +6)
DRVGEO EQU   $06A6						; base to sectors/track (D1: $6A7 - D2: $6A8 - D3: $6A9 - D4: $6AA  step = +1)
;
DIMASK EQU   $50							; mask to disable interrupts(FIRQ and IRQ)
EIMASK EQU   $AF                    ; mask to enable interrupts
NAMBUF EQU   $01D1						; fixed by BASIC, read filename function which stores in $1d1
HEADER EQU   $1B00                  ; place where VDK header (sector zero) is to be created (1B00-1BFF)
RAMINI EQU   $1C00						; where to copy the 90 data sectors of each pack
RAMMAX EQU   $75FF						; RAM limit to be filled (23,040KB = 90 sectors)
FLODIR EQU   $7600                  ; Area where sector 1 of drive directory will be read
;
WAITKY EQU   $852B                  ; wait for a key
OUTSTR EQU   $90E5						; print string at X+1 to DEVNUM
OUTNUM EQU   $957A			         ; print number in D to DEVNUM
OUTCHR EQU   $B54A					   ; print char at reg 'A' to DEVNUM
GETNAM EQU   $B7AA						; read file name and length into $1d1
IOERR  EQU   $B84B						; IO ERROR message
FRDSEC EQU   $C026                  ; read a sector from disk to user buffer
FRDIR  EQU   $C104                  ; read a directory sector from disk
;
ENTRY  LDX   ,S							; get stack pointer into reg 'X'
       LDU   1,X							; get 1ST address from vector table
       STU   DWRVEC  					; save as vector for DWREAD
       LDU   3,X							; get 2nd address from vector table
       STU   DWWVEC						; save as vector for DWWRITE
;
GETN   ORCC  #DIMASK	            	; disable FIRQ, IRQ (to work with DW4)
		 JSR   GETNAM						; read VDK file name and length into $1d1 = nambuf
       LDX   #NAMBUF-1					; byte before packet buffer start
       CLR   ,X							; zero MSB to make a 16 bit value for Y
       LDY   ,X++							; length of file name (16 bit)
       BEQ   FAILED						; if len=0 no file entered
       LDB   -1,X							; length of name (8 bit)
;											; Adding .VDK if not termination entered       
		 PSHS  B,X							; save pointer to beginning of name and name length
ISDOT  LDA   ,X+							; get a char from name
       CMPA  #'.							; is it a dot?
       BEQ   ALRDOT						; yes, stop search, quit loop
       DECB									; decrement counter
       BNE   ISDOT						; not end of string, get next char name
       LDD   #$2E56						; get chars ".V"
       STD   ,X++							; add to end of name
       LDD   #$444B						; get chars "DK"
       STD   ,X++							; add to end of name
		 LDB   ,S							; get old name length
		 ADDB  #4							; add 4 (because of .VDK added)
		 STB   ,S							; update new length in stack
       STB   NAMBUF						; save new length in byte before string
       LEAY  4,Y                    ; correction to name length - DW parameter
ALRDOT PULS  B,X       					; restore pointer and length
       CLR   B,X							; zero terminate name string (for error)
       INC   ,--X							; opcode 1 = DW OP_NAMEOBJ_MOUNT command
       INC   ,X       					; opcode 2 = DW OP_NAMEOBJ_CREATE command (fails by now)
       LEAY  2,Y							; length of DW packet = name length + 2
       JSR   [DWWVEC,PCR]				; send create file request to server
       LDX   #DNUM						; our drive number variable
       CLR   ,X							; clear it
       LEAY  1,Y							; read one byte back
       JSR   [DWRVEC,PCR]				; get drive number
       TST   ,X							; verify received value
       BNE   FLOPPY						; successfully created                                       
;											; Messages Dispatch
MSG07  LDX   #NOCRTD-1					; point to error message "VDK not created"  
		 FCB   #$10							; forms LDY #xxxx with next instruction, to jump it
MSG06  LDX   #NODISK-1					; point to error message "No disk at drive"  
		 FCB   #$10							; forms LDY #xxxx with next instruction, to jump it
MSG05  LDX   #UNKNWN-1              ; point to errro message "Unknown Disk format"
    	 ANDCC #EIMASK						; enable interrupts
		 FCB   #$10							; forms LDY #xxxx with next instruction, to jump it
MSG03  LDX   #OSTEXT-1					; points to intro message for OS9 disk copy
		 FCB   #$10							; forms LDY #xxxx with next instruction, to jump it
MSG02	 LDX   #INSERT-1					; point to message asking for a floppy
		 FCB   #$10							; forms LDY #xxxx with next instruction, to jump it
MSG01  LDX   #LDTEXT-1					; point to intro message for DOS disk copy
       JSR   OUTSTR						; print message to screen
		 RTS									; return
;
FAILED ANDCC #EIMASK						; enable interrupts
	    JMP   IOERR						; I/O error message
;											; Get geometry parameters of the default floppy
FLOPPY ANDCC #EIMASK			 			; enable interrupts to work with the drive
		 BSR   MSG02						; show message asking for a floppy to be put at default drive
		 JSR   WAITKY 						; wait for a key to be pressed
		 LDA   >DEFDRV						; get default drive
		 STA   <WRKDRV						; save at working actual drive
											; read data as if it were a DOS disk
       LDD   #$1401					   ; A=20 - B=1 (directory always begins at sector 1 of track 20)
		 STD   <WRKTRK						; $EC=track (20) - $ED=sector (1)
	    LDX   #FLODIR						; point to buffer area for 1st directory sector of floppy
	    STX   <WRKBUF						; store at working buffer address for disk command
		 JSR   FRDIR					; read the requested directory disk sector
		 TSTB									; detected error reading directory?
		 BNE   MSG06						; yes, show message
		 LDX	 <WRKBUF	 					; point to the beginning of directory buffer area
		 LDD   +252,X						; A=(FLODIR+252) = number of tracks  -  B=(FLODIR+253) = number of sectors per side
		 stb	 <numsec						; save number of sectors x track for later calculations
		 MUL									; total number of tracks of the floppy (720 - 1440 - 1440 - 2880)
											; verify if the disk is a DOS one
		 CMPD  #720							; is it a 180k disk?
		 BEQ   GODOS						; yes, proceed, is a DOS disk
		 CMPD  #1440						; is it a 360k disk?
		 BEQ   GODOS						; yes, proceed, is a DOS disk
		 CMPD  #2880						; is it a 720k disk?
		 BEQ   GODOS						; yes, proceed, is a DOS disk
											; see if this is an OS-9 or NitrOS-9 disk
       LDD   #$0001					   ; A=0 - B=1 (directory always begins at sector 1 of track 0)
		 STD   <WRKTRK						; $EC=track (00) - $ED=sector (1)
	    LDX   #FLODIR						; point to buffer area for 1st directory sector of floppy
	    STX   <WRKBUF						; store at working buffer address for disk command
		 JSR   FRDIR					; read the requested directory disk sector
		 TSTB									; detected error reading directory?
		 BNE   MSG06						; yes, show message
		 LDX	 <WRKBUF	 					; point to the beginning of directory buffer area
		 ldb	 #18							; get minimum of 18 sectors x track
		 lda	 $10,x						; get number of sides
		 anda	 #1							; is bit0 set? if so, double sided
		 beq	 onesid						; no, do not double
		 aslb									; B=36 (double sided disk)
onesid stb	 <numsec						; save number of sectors x track for later calculations
		 LDD   1,X						   ; D= total number of sectors
											; verify if we have got geometry data
		 CMPD  #720							; is it a 180k disk?
		 BEQ   GOOS9						; yes, proceed, is an OS9 disk
		 CMPD  #1440						; is it a 360k disk?
		 BEQ   GOOS9						; yes, proceed, is an OS9 disk
		 CMPD  #2880						; is it a 720k disk?
		 BEQ   GOOS9						; yes, proceed, is an OS9 disk
		 LBRA  MSG05						; show error, disk neither DOS nor OS9 
;
GODOS	 SUBD  #1	 						; to control untill 719 - 1439 - 1439 - 2879 
		 STD   <totsec						; save calculated number of sectors
 		 BSR   MSG01 					   ; print initial message for DOS disk copy
		 BRA   LETSGO						; proceed to copy it
GOOS9	 SUBD  #1							; to control untill 719 - 1439 - 1439 - 2879 
		 STD   <totsec						; save calculated number of sectors
     	 LBSR  MSG03 					   ; print initial message for OS9 disk copy
;											; Update working DOS variables upon disk and default drive		 

LETSGO ldx   #360							; dir init for single sided discs
		 lda	 <numsec						; get number of sectors x track (18, 36)
		 cmpa	 #18							; is it single sided?
		 beq   dontx2						; yes, do not double
       LDx	 #720 						; set 1st directory sector for greater disks (40x36 and 80x36)
dontx2 LDU	 #DRVGEO						; point to byte before data for drive1
	    LDB   <WRKDRV						; get working drive number
	    STA	 B,U							; save number of sectors at the calculated drive area
	    LDU   #DRVINF						; point to 6 bytes before data for drive1
NXTDRV LEAU  6,U							; add 6 to pointer
	    DECB									; decrement drive number
	    BNE   NXTDRV						; if not zero, keep adding 6 (next drive)
		 STx   ,U		 					; save 1st directory sector to pointed area
;                             	; Create header for VDK and send it to DW4 (write sector zero)
		 LDX   #HEADER						; points to header at RAM
		 LDU   #STDHDR						; points to std header data
FILL	 LDD   ,U++							; get two bytes
		 STD   ,X++							; put at RAM header
		 CMPU  #SOURCE						; all 8 bytes copied?
		 BLS   FILL 						; no, keep on
		 ldb	 #1							; one side disk
		 lda	 <numsec						; get sectors x track
		 cmpa	 #18							; is 18 (single sided)?
		 beq	 dd2							; yes, do not double
		 aslb									; 2 sides
dd2	 stb	 1,x							; puts number of sides one byte ahead
		 ldb	 #40							; numer of tracks
		 ldu	 <totsec						; get number of sectors of the whole disk
		 cmpa	 #36							; is it double sided?
		 beq	 ds2							; goto double sided
		 cmpu	 #719							; is it 720K disk?		 
ss2	 beq	 allok						; yes, write data
		 aslb									; double number of tracks
		 bra	 allok						; write data
ds2	 cmpu  #1439						; is it 1440k (single density)?
		 bra   ss2							; go compare
allok	 stb   ,X++							; put track - sides into header
	    CLRA
	    CLRB									; create 16 bit zero
	    STD   <SEC1ST						; first sector to be read should be LSN = 0
CLEAN	 STD   ,X++							; fill with zero untill the end of the header
		 CMPX  #RAMINI						; got to the end (256 bytes)?
		 BLO   CLEAN						; no, keep on
		 LDX	 <SEC1ST						; sector to be sent as header
		 LDY   #HEADER						; pointer to header data
		 LBSR  DOWRIT						; write sector number zero to DW4 from header
		 LBCS  FAILED						; if error, quit
;                             	; Read packs of 90 sectors from disk and send them to DW4
RDFLO  BSR	 SHOW1						; show sectors to be copied
       ANDCC #EIMASK						; enable interrupts to work with the drive
		 LDY   <SEC1ST						; get first sector to be read in this pack
		 LDX   #RAMINI						; point to RAM initial address  (Y = $1C00)
RDLOOP PSHS  Y								; save sector number
												; it seems that DosPlus4.9 needs the total sectors x track to be updated here
		 lda	 <numsec						; A should get here 18 for single sided or 36 for double sided disks
       LDU	 #DRVGEO						; point to byte before data for drive1
	    LDB   <WRKDRV						; get working drive number
	    STA	 B,U							; save number of setors at the calculated drive area
		 JSR   [FRDSEC]					; read sector Y from disk (into X)  -  need X -> RAM bufffer (preserved) and  Y -> sector number
		 PULS  Y								; get last read sector number
		 TSTB									; operation succeeded?
		 LBNE  FAILED   					; no, quit
       LEAY  1,Y							; next sector number
       LEAX  +256,X						; point to next sector address in RAM
       CMPX  #RAMMAX						; got to the RAM limit?	(X > $75FF)
       BLO   RDLOOP						; no, keep on reading sectors from the floppy
SPIN   LDB   >MOTTIM       			; is motor disk spinning
		 BNE   SPIN							; yes, wait
       ORCC  #DIMASK						; disable interrupts to work with DW4
		 BSR   SENDPK                 ; send the whole pack at RAM to DW4
		 STY   <SEC1ST						; save 1st sector for next pack
		 CMPY  <totsec                ; copied the whole floppy?
       BLO   RDFLO                  ; no, go process next pack
    	 ANDCC #EIMASK						; enable interrupts
       RTS									; return to the caller
;												; messages to show program progress
SHOW1  LDX   #BEGIN-1					; point to message prior to read sectors
		 FCB   #10							; byte to jump over next instruction, gives LDY #xxxx
SHOW2	 LDX   #DONE-1						; point to message post writting sectors
   	 JSR   OUTSTR						; show message
   	 LDX	 #TEXT1-1					; point to common message part 1
		 JSR	 OUTSTR						; show message
		 LDD   <SEC1ST						; get first loaded sector
		 JSR   OUTNUM						; print it to screen
		 LDX	 #TEXT2-1					; point to common message part 2
		 JSR	 OUTSTR						; show message
		 LDD   <SEC1ST						; get first loaded sector
		 ADDD  #89							; add 89 (last one loaded)
		 JSR	 OUTNUM						; print it to screen
		 LDA	 #$0D							; get ASCII for CR
		 JSR	 OUTCHR						; printo to screen
		 RTS									; return
;----------------------------------------------------------------------------------------
; Sends 90 sectors with data pointed by 'Y'. 1st sector LSN in 'X' (no parameters needed)
;----------------------------------------------------------------------------------------
SENDPK PSHS  Y 							; save 1st sector for next pack
		 LDX   <SEC1ST   				   ; get 1st sector of the pack to be saved
		 LEAX	 1,X							; LSN begins from 0 to 719 - 1439 - 2879 (but we must write to DW from 1 to n)
       LDY   #RAMINI      				; point to beginning of RAM data
       LDA   #90        				; number of sectors to send in a pack
SNDBLK PSHS  A								; save counter
		 BSR   DOWRIT						; send sector to DW4 from HEADER (Y->RAM Buffer - X->sector number)
		 PULS  A								; get counter
		 LBCS  FAILED						; if error, quit
       LEAY  +256,Y       				; point to next sector in RAM buffer
       LEAX  1,X          				; increment LSN (next sector)
       DECA               				; decrement sector counter
       BNE   SNDBLK       				; if not yet finished, keep on sending to DW
       LDD   <CURPOS						; get current cursor position
       SUBD	 #32							; go one row up
       STD   <CURPOS						; save new position. Next message will overlap last one
		 BSR	 SHOW2						; show sectors just sent
       PULS  Y,PC 						; end of send block
;----------------------------------------------------------------------------------------
; By now this must calculate the checksum (maybe could fit inside DWWrite?)
; register Y holds "RAM pointer"  -  X holds "Sector number"
;----------------------------------------------------------------------------------------
DOWRIT LDA   <DNUM						; our drive number
       CLRB						         ; LSN bits 23-16
       PSHS  A,B,X,Y			         ; save registers / data					STACK: RETADRS, YL, YH, SectorL, SectorH, $0, DNUM
       										; calculate Checksum for that sector
       LDX	 #0							; checksum to zero
       CLRA									; byte counter
CALC   LDB	 ,Y+							; read a byte
       ABX									; add to checksum
       DECA									; decrement counter
       BNE   CALC							; if not all 256, keep on
       STX   <CHKSUM						; save checksum
		 LDA   #$57                   ; DW OP_WRITE (write one sector)
REWRIT PSHS  A					         ; save command onto stack				STACK: RETADRS, YL, YH, SectorL, SectorH, $0, DNUM, OP_WRITE
       LEAX  ,S				         ; point X to top of stack
       LDY   #5      			      ; 5 bytes
       JSR   [DWWVEC,PCR]	         ; send 5 bytes to DW		-   OP_WRITE, DNUM, $0, Sector(H-L)
       PULS  A					         ; discard command							STACK: RETADRS, YL, YH, SectorL, SectorH, $0, DNUM
       LDX   4,S				         ; get sector buffer pointer = received Y
       LDY   #$0100			         ; write 256 bytes
       JSR   [DWWVEC,PCR]	         ; send sector (256 bytes)
		 LDY   <CHKSUM						; get calculated checksum
       PSHS  Y					         ; save it onto stack			   		STACK: RETADRS, YL, YH, SectorL, SectorH, $0, DNUM, ChksumL, ChksumH
       LEAX  ,S				         ; point X to top of stack (Checksum)
       LDY   #2				         ; 2 bytes
       JSR   [DWWVEC,PCR]		      ; send checksum to DW4
									   	; get answer from DW to this pack
		 LEAY  1,Y				         ; after a DWRITE Y returns zeroed, so this way it becomes equal to one
       LDD   #133	   		         ; 1 second timeout (what is it for???) 
       JSR   [DWRVEC,PCR]	         ; read DW answer	- this overwrites DNUM byte
       LEAS  2,S				         ; discard checksum						STACK: RETADRS, YL, YH, SectorL, SectorH, $0, Returnedvalue
       BCS   WRITEX			         ; detect framing error
       BNE   WRITEX			         ; detect not all bytes received
       LDA   ,S				         ; get server answer (in old DNUM position)
       BEQ   WRITEX			         ; zero=OK, go out
       CMPA  #$F3				         ; error type = #E_CRC?
       BNE   WRITER			         ; not this one, go out signaling framing error
		 LDA   <DNUM        		      ; get drive number
       STA   ,S				         ; put again in stack						STACK: RETADRS, YL, YH, SectorL, SectorH, $0, DNUM
       LDA   #$77							; DW code for OP_REWRITE
       BRA   REWRIT			         ; rewrite same sector
WRITER COMB						         ; sets the carry flag (ERROR)
WRITEX PULS  A,B,X,Y,PC             ; restore registers and return      STACK: - - -
;----------------------------------------------------------------------------------------
LDTEXT FCC   /COPY DOS /
		 FCC   /DISK/,13,0		   	; intro message to the user for DOS disks
OSTEXT FCC   /COPY OS9 /
		 FCC   /DISK/,13,0         	; intro message to the user for OS-9 disks
INSERT FCC   /INSERT DISK AT /
		 FCC   /DEFAULT DRIVE/,13
		 FCC   /PRESS A KEY/,13,0		; ask for a floppy
NODISK FCC   /NO DISK FOUND/,0      ; No disk or not formatted
NOCRTD FCC   /VDK NOT CREATED/,0    ; Could not create Named Object
UNKNWN FCC   /UNKNOWN DISK /
       FCC   /FORMAT/,0					; disk format unknown
BEGIN  FCC   / COPY/,0					; before copying a block
DONE   FCC   /saved/,0					; after saving the block
TEXT1  FCC   / SECTORS: /,0		   ; fixed text
TEXT2  FCC   / - /,0						; separator
;
STDHDR FCB   $64,$6B,0,1,16,16		; Data to create the VDK header
SOURCE FCB   3,0							; source of the VDK
;
DWRVEC FDB   0								; indirect jump to drivewire read function
DWWVEC FDB   0								; indirect jump to drivewire write function 
;----------------------------------------------------------------------------------------
		 IF ((*+9)%256 > 0)
		    rzb	 256-((*+9)%256)		; make it DW4 compatible (length multiple of 256 bytes)
		 ENDIF
;----------------------------------------------------------------------------------------
